﻿package 
{
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import fl.transitions.Tween;
	import fl.transitions.easing.Strong;

	public class Main extends Sprite
	{
		private var dots:Array = [];
		private var pattern:Array = [];
		private var pass:Array = [1,2,3,6,9,8,5];

		public function Main():void
		{
			dots = [one,two,three,four,five,six,seven,eight,nine];
			addListeners();
		}

		private function addListeners():void
		{
			var dotsLength:int = dots.length;

			for (var i:int = 0; i < dotsLength; i++)
			{
				dots[i].addEventListener(MouseEvent.MOUSE_DOWN, initiatePattern);
				dots[i].addEventListener(MouseEvent.MOUSE_UP, stopPattern);
			}
		}

		private function initiatePattern(e:MouseEvent):void
		{
			var dotsLength:int = dots.length;

			for (var i:int = 0; i < dotsLength; i++)
			{
				dots[i].addEventListener(MouseEvent.MOUSE_OVER, addPattern);
			}

			pattern.push(dots.indexOf(e.target) + 1);
		}

		private function addPattern(e:MouseEvent):void
		{
			pattern.push(dots.indexOf(e.target) + 1);
		}

		private function stopPattern(e:MouseEvent):void
		{
			var dotsLength:int = dots.length;

			for (var i:int = 0; i < dotsLength; i++)
			{
				dots[i].removeEventListener(MouseEvent.MOUSE_OVER, addPattern);
			}

			checkPattern();
		}

		private function checkPattern():void
		{
			var pLength:int = pass.length;
			var correct:int = 0;

			for (var i:int = 0; i < pLength; i++)
			{
				if (pass[i] == pattern[i])
				{
					correct++;
				}
			}

			if (correct == pLength)
			{
				var sView:SecondView = new SecondView();

				addChild(sView);

				var tween:Tween = new Tween(sView,"x",Strong.easeOut,320,0,0.8,true);
			}

			pattern = [];
		}
	}
}